<?php
/**
 * backend tab to configure plugin settings
 *
 * @category   plugin
 * @package    ekomi_integration
 * @author     Sandor Barics <sbarics@ekomi.de>
 */
require_once dirname(__DIR__) . '/includes/class.ekomi_integration.helper.php';
require_once dirname(__DIR__) . '/includes/class.ekomi_integration_manager.inc.php';

$helper = ekomiIntegrationHelper::getInstance($oPlugin);

$stepPlugin = 'settings';
$successMsg = '';
$errorMsg = '';
$customPluginTabs = array();
$invalidateCache = false;

// get the plugin id
$kPlugin = verifyGPCDataInteger('kPlugin');
if ($kPlugin > 0) {

    if (isset($_POST['cPluginTab']) && $_POST['cPluginTab'] == $stepPlugin && validateToken()) {

        $oPluginEinstellungConf_arr = $helper->fetchConfigSettings($kPlugin, intval($_POST['kPluginAdminMenu']));

        if (count($oPluginEinstellungConf_arr) > 0) {

            $ekomiIntegrationManager = new ekomiIntegrationManager(verifyGPCDataInteger('ekomi_integration_id'), trim($_POST['ekomi_integration_password']));
            
            // validates the shop credentials
            $validated = $ekomiIntegrationManager->validateShop();

            $showSuccess = TRUE;
            
            // Deleting all configurations and saving again
            foreach ($oPluginEinstellungConf_arr as $oPluginEinstellungConf) {

                $helper->deleteConfig($kPlugin, $oPluginEinstellungConf->cWertName);

                $cWert = null;

                if (isset($_POST[$oPluginEinstellungConf->cWertName])) {
                    if (is_array($_POST[$oPluginEinstellungConf->cWertName])) {
                        //multi select
                        $cWert = implode(',', $_POST[$oPluginEinstellungConf->cWertName]);
                    } else {
                        //textarea/text
                        $cWert = trim($_POST[$oPluginEinstellungConf->cWertName]);
                    }
                }
                
                // save if shop is validated
                if ($validated) {
                    $kKey = $helper->saveConfig($kPlugin, $oPluginEinstellungConf->cWertName, $cWert);

                    if (!$kKey) {
                        $errorMsg = 'Shop Id or password is invalid';
                        $showSuccess = FALSE;
                    }
                } else {
                    $errorMsg = 'Shop Id or password is invalid';
                    $showSuccess = FALSE;
                }
            }
            $invalidateCache = true;

            if ($validated && $showSuccess) {
                $successMsg = 'Configuration saved successfully';
            }

            $oPlugin = new Plugin($kPlugin, $invalidateCache);
            $smarty->assign('oPlugin', $oPlugin);
        }
    }

    //get plugin settigns to show on page
    $confiArr = $helper->toAssociativeArray($oPlugin->oPluginEinstellung_arr);
    $confiArr['ekomi_integration_order_statuses'] = explode(',', $confiArr['ekomi_integration_order_statuses']);
}
$smarty->assign("stepPlugin", $stepPlugin)
        ->assign('cHinweis', $successMsg)
        ->assign('cFehler', $errorMsg)
        ->assign('confiArr', $confiArr)
        ->display($oPlugin->cAdminmenuPfad . 'templates/settings.tpl');
